import sys
import requests
import fin_depo
from . import secrets
from fin_defs import CryptoCurrency, AssetAmount, MPC, Asset, USDT
from decimal import Decimal
from collections import deque
from fin_depo.data import *
import datetime
import dataclasses
import logging
from pathlib import Path

from . import compute_fifo, output_excel

KUCOIN_CLIENT = fin_depo.defi_kucoin.KucoinDepoFetcher(
    secrets.KUCOIN_KEY,
    secrets.KUCOIN_SECRET,
    secrets.KUCOIN_PASS,
)

KRAKEN_CLIENT = fin_depo.defi_kraken.KrakenDepoFetcher(
    secrets.KRAKEN_KEY,
    secrets.KRAKEN_SECRET,
)

def main():
    """Main function."""

    logging.basicConfig()
    logger = logging.getLogger('crypto_tax')
    logger.setLevel('INFO')

    TRANSFERS = []
    TRANSFERS += list(KRAKEN_CLIENT._get_double_registers())
    TRANSFERS += list(KUCOIN_CLIENT._get_double_registers())
    tax_report = compute_fifo(TRANSFERS)

    output_path = Path('./output/report.xlsx')
    output_excel.produce_excel_report(tax_report, output_path)



if __name__ == '__main__':
    main()

